// This file is generated by kconfig_compiler from kdissert.kcfg.
// All changes you do to this file will be lost.
#ifndef SETTINGS_H
#define SETTINGS_H

#include <kconfigskeleton.h>
#include <kdebug.h>

#include <klocale.h>
class Settings : public KConfigSkeleton
{
  public:
    class EnumLinkStyle
    {
      public:
      enum type { line, spline, thickspline, COUNT };
    };
    class EnumColorMode
    {
      public:
      enum type { root_, default_, theme1_, theme2_, theme3_, theme4_, theme5_, theme6_, custom_, COUNT };
    };

    static Settings *self();
    ~Settings();

    /**
      Set Default author first name
    */
    static
    void setFname( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "fname" ) ))
        self()->mFname = v;
    }

    /**
      Get Default author first name
    */
    static
    QString fname()
    {
      return self()->mFname;
    }

    /**
      Set Default author name
    */
    static
    void setSname( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "sname" ) ))
        self()->mSname = v;
    }

    /**
      Get Default author name
    */
    static
    QString sname()
    {
      return self()->mSname;
    }


    /**
      Get Default author's e-mail address
    */
    static
    QString email()
    {
      return self()->mEmail;
    }


    /**
      Get Default author's company or institution name
    */
    static
    QString company()
    {
      return self()->mCompany;
    }


    /**
      Get Default country code for OpenOffice.org documents
    */
    static
    QString countrycode()
    {
      return self()->mCountrycode;
    }


    /**
      Get use the inline editor
    */
    static
    bool inlineEditor()
    {
      return self()->mInlineEditor;
    }


    /**
      Get Color of the background
    */
    static
    QColor col_background()
    {
      return self()->mCol_background;
    }


    /**
      Get Color of the links
    */
    static
    QColor col_link()
    {
      return self()->mCol_link;
    }


    /**
      Get Color of the references
    */
    static
    QColor col_ref()
    {
      return self()->mCol_ref;
    }


    /**
      Get Size of the arrows showing the direction
    */
    static
    int showDirectionSize()
    {
      return self()->mShowDirectionSize;
    }


    /**
      Get Show pictures on the canvas view
    */
    static
    bool picturesOnCanvas()
    {
      return self()->mPicturesOnCanvas;
    }


    /**
      Get Reorganize the map objects in a cycle
    */
    static
    bool reorgCyclicMap()
    {
      return self()->mReorgCyclicMap;
    }


    /**
      Get Nagivate in the hierarchy
    */
    static
    bool selHierarchic()
    {
      return self()->mSelHierarchic;
    }


    /**
      Get Generate documents using UTF8
    */
    static
    bool templatesUTF8()
    {
      return self()->mTemplatesUTF8;
    }


    /**
      Get The text in the comment zone is LaTeX code
    */
    static
    bool commentTex()
    {
      return self()->mCommentTex;
    }


    /**
      Get New items inherit the parent style
    */
    static
    bool inherit()
    {
      return self()->mInherit;
    }


    /**
      Get Command for launching URLs
    */
    static
    QString launchCommand()
    {
      return self()->mLaunchCommand;
    }


    /**
      Get Reorganize the map automatically
    */
    static
    bool automode()
    {
      return self()->mAutomode;
    }


    /**
      Get Size of the pixmaps displayed
    */
    static
    int pixSize()
    {
      return self()->mPixSize;
    }


    /**
      Get Default canvas font.
    */
    static
    QFont canvasFont()
    {
      return self()->mCanvasFont;
    }


    /**
      Get LinkStyle mode
    */
    static
    int linkStyle()
    {
      return self()->mLinkStyle;
    }


    /**
      Get Color mode
    */
    static
    int colorMode()
    {
      return self()->mColorMode;
    }


    /**
      Get Fill colors
    */
    static
    QColor fillcolor( int i )
    {
      return self()->mFillcolor[i];
    }


    /**
      Get Outline colors
    */
    static
    QColor outlinecolor( int i )
    {
      return self()->mOutlinecolor[i];
    }


    /**
      Get Text colors
    */
    static
    QColor textcolor( int i )
    {
      return self()->mTextcolor[i];
    }


    /**
      Get Annotation for theme
    */
    static
    QString annotation( int i )
    {
      return self()->mAnnotation[i];
    }


    /**
      Get Backup previousely generated documents before overwriting
    */
    static
    bool backupGenerated()
    {
      return self()->mBackupGenerated;
    }


    /**
      Get Merge with previousely generated documents
    */
    static
    bool mergeGenerated()
    {
      return self()->mMergeGenerated;
    }

    static
    void writeConfig()
    {
      static_cast<KConfigSkeleton*>(self())->writeConfig();
    }
  protected:
    Settings();
    static Settings *mSelf;


    // Preferences
    QString mFname;
    QString mSname;
    QString mEmail;
    QString mCompany;
    QString mCountrycode;
    bool mInlineEditor;
    QColor mCol_background;
    QColor mCol_link;
    QColor mCol_ref;
    int mShowDirectionSize;
    bool mPicturesOnCanvas;
    bool mReorgCyclicMap;
    bool mSelHierarchic;
    bool mTemplatesUTF8;
    bool mCommentTex;
    bool mInherit;
    QString mLaunchCommand;
    bool mAutomode;
    int mPixSize;
    QFont mCanvasFont;
    int mLinkStyle;
    int mColorMode;
    QColor mFillcolor[9];
    QColor mOutlinecolor[9];
    QColor mTextcolor[9];
    QString mAnnotation[9];
    bool mBackupGenerated;
    bool mMergeGenerated;

  private:
};

#endif

